# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class CertificateAuthority(pulumi.CustomResource):
    """
    Provides a resource to manage AWS Certificate Manager Private Certificate Authorities (ACM PCA Certificate Authorities).
    
    > **NOTE:** Creating this resource will leave the certificate authority in a `PENDING_CERTIFICATE` status, which means it cannot yet issue certificates. To complete this setup, you must fully sign the certificate authority CSR available in the `certificate_signing_request` attribute and import the signed certificate outside of Terraform. Terraform can support another resource to manage that workflow automatically in the future.
    """
    def __init__(__self__, __name__, __opts__=None, certificate_authority_configuration=None, enabled=None, revocation_configuration=None, tags=None, type=None):
        """Create a CertificateAuthority resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not certificate_authority_configuration:
            raise TypeError('Missing required property certificate_authority_configuration')
        __props__['certificate_authority_configuration'] = certificate_authority_configuration

        __props__['enabled'] = enabled

        __props__['revocation_configuration'] = revocation_configuration

        __props__['tags'] = tags

        __props__['type'] = type

        __props__['arn'] = None
        __props__['certificate'] = None
        __props__['certificate_chain'] = None
        __props__['certificate_signing_request'] = None
        __props__['not_after'] = None
        __props__['not_before'] = None
        __props__['serial'] = None
        __props__['status'] = None

        super(CertificateAuthority, __self__).__init__(
            'aws:acmpca/certificateAuthority:CertificateAuthority',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

