# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class Cluster(pulumi.CustomResource):
    """
    Creates an Amazon CloudHSM v2 cluster.
    
    For information about CloudHSM v2, see the
    [AWS CloudHSM User Guide][1] and the [Amazon
    CloudHSM API Reference][2].
    
    > **NOTE:** CloudHSM can take up to several minutes to be set up.
    Practically no single attribute can be updated except TAGS.
    If you need to delete a cluster, you have to remove its HSM modules first.
    To initialize cluster you have to sign CSR and upload it.
    """
    def __init__(__self__, __name__, __opts__=None, hsm_type=None, source_backup_identifier=None, subnet_ids=None, tags=None):
        """Create a Cluster resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not hsm_type:
            raise TypeError('Missing required property hsm_type')
        __props__['hsm_type'] = hsm_type

        __props__['source_backup_identifier'] = source_backup_identifier

        if not subnet_ids:
            raise TypeError('Missing required property subnet_ids')
        __props__['subnet_ids'] = subnet_ids

        __props__['tags'] = tags

        __props__['cluster_certificates'] = None
        __props__['cluster_id'] = None
        __props__['cluster_state'] = None
        __props__['security_group_id'] = None
        __props__['vpc_id'] = None

        super(Cluster, __self__).__init__(
            'aws:cloudhsmv2/cluster:Cluster',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

