# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class Table(pulumi.CustomResource):
    """
    Provides a DynamoDB table resource
    
    > **Note:** It is recommended to use `lifecycle` [`ignore_changes`](https://www.terraform.io/docs/configuration/resources.html#ignore_changes) for `read_capacity` and/or `write_capacity` if there's [autoscaling policy](https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html) attached to the table.
    """
    def __init__(__self__, __name__, __opts__=None, attributes=None, billing_mode=None, global_secondary_indexes=None, hash_key=None, local_secondary_indexes=None, name=None, point_in_time_recovery=None, range_key=None, read_capacity=None, server_side_encryption=None, stream_enabled=None, stream_view_type=None, tags=None, ttl=None, write_capacity=None):
        """Create a Table resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not attributes:
            raise TypeError('Missing required property attributes')
        __props__['attributes'] = attributes

        __props__['billing_mode'] = billing_mode

        __props__['global_secondary_indexes'] = global_secondary_indexes

        if not hash_key:
            raise TypeError('Missing required property hash_key')
        __props__['hash_key'] = hash_key

        __props__['local_secondary_indexes'] = local_secondary_indexes

        __props__['name'] = name

        __props__['point_in_time_recovery'] = point_in_time_recovery

        __props__['range_key'] = range_key

        __props__['read_capacity'] = read_capacity

        __props__['server_side_encryption'] = server_side_encryption

        __props__['stream_enabled'] = stream_enabled

        __props__['stream_view_type'] = stream_view_type

        __props__['tags'] = tags

        __props__['ttl'] = ttl

        __props__['write_capacity'] = write_capacity

        __props__['arn'] = None
        __props__['stream_arn'] = None
        __props__['stream_label'] = None

        super(Table, __self__).__init__(
            'aws:dynamodb/table:Table',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

