# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class Instance(pulumi.CustomResource):
    """
    Provides a Lightsail Instance. Amazon Lightsail is a service to provide easy virtual private servers
    with custom software already setup. See [What is Amazon Lightsail?](https://lightsail.aws.amazon.com/ls/docs/getting-started/article/what-is-amazon-lightsail)
    for more information.
    
    > **Note:** Lightsail is currently only supported in a limited number of AWS Regions, please see ["Regions and Availability Zones in Amazon Lightsail"](https://lightsail.aws.amazon.com/ls/docs/overview/article/understanding-regions-and-availability-zones-in-amazon-lightsail) for more details
    """
    def __init__(__self__, __name__, __opts__=None, availability_zone=None, blueprint_id=None, bundle_id=None, key_pair_name=None, name=None, user_data=None):
        """Create a Instance resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not availability_zone:
            raise TypeError('Missing required property availability_zone')
        __props__['availability_zone'] = availability_zone

        if not blueprint_id:
            raise TypeError('Missing required property blueprint_id')
        __props__['blueprint_id'] = blueprint_id

        if not bundle_id:
            raise TypeError('Missing required property bundle_id')
        __props__['bundle_id'] = bundle_id

        __props__['key_pair_name'] = key_pair_name

        __props__['name'] = name

        __props__['user_data'] = user_data

        __props__['arn'] = None
        __props__['cpu_count'] = None
        __props__['created_at'] = None
        __props__['ipv6_address'] = None
        __props__['is_static_ip'] = None
        __props__['private_ip_address'] = None
        __props__['public_ip_address'] = None
        __props__['ram_size'] = None
        __props__['username'] = None

        super(Instance, __self__).__init__(
            'aws:lightsail/instance:Instance',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

